diff a/src/hotspot/share/opto/graphKit.hpp b/src/hotspot/share/opto/graphKit.hpp
--- a/src/hotspot/share/opto/graphKit.hpp
+++ b/src/hotspot/share/opto/graphKit.hpp
@@ -138,10 +138,11 @@
   int                sp()       const { return _sp; }
   int                bci()      const { return _bci; }
   Bytecodes::Code    java_bc()  const;
   ciMethod*          method()   const { return _method; }
 
+  PartialEscapeAnalysis* PEA() const { return C->PEA(); }
   void set_jvms(JVMState* jvms)       { set_map(jvms->map());
                                         assert(jvms == this->jvms(), "sanity");
                                         _sp = jvms->sp();
                                         _bci = jvms->bci();
                                         _method = jvms->has_method() ? jvms->method() : nullptr; }
@@ -829,11 +830,12 @@
   int next_monitor();
   Node* insert_mem_bar(int opcode, Node* precedent = nullptr);
   Node* insert_mem_bar_volatile(int opcode, int alias_idx, Node* precedent = nullptr);
   // Optional 'precedent' is appended as an extra edge, to force ordering.
   FastLockNode* shared_lock(Node* obj);
-  void shared_unlock(Node* box, Node* obj);
+  void shared_unlock(Node* box, Node* obj, bool preserve_monitor = false);
+  void clone_shared_lock(Node* box, Node* obj);
 
   // helper functions for the fast path/slow path idioms
   Node* fast_and_slow(Node* in, const Type *result_type, Node* null_result, IfNode* fast_test, Node* fast_result, address slow_call, const TypeFunc *slow_call_type, Node* slow_arg, Klass* ex_klass, Node* slow_result);
 
   // Generate an instance-of idiom.  Used by both the instance-of bytecode
@@ -855,14 +857,21 @@
 
   // Inexact type check used for predicted calls.
   Node* subtype_check_receiver(Node* receiver, ciKlass* klass,
                                Node** casted_receiver);
 
+  Node* set_output_for_allocation_common(AllocateNode* alloc,
+                                  const TypeOopPtr* oop_type,
+                                  bool deoptimize_on_exception);
+
   // implementation of object creation
   Node* set_output_for_allocation(AllocateNode* alloc,
                                   const TypeOopPtr* oop_type,
                                   bool deoptimize_on_exception=false);
+
+  Node* materialize_object(AllocateNode* alloc, const TypeOopPtr* oop_type);
+
   Node* get_layout_helper(Node* klass_node, jint& constant_value);
   Node* new_instance(Node* klass_node,
                      Node* slow_test = nullptr,
                      Node* *return_size_val = nullptr,
                      bool deoptimize_on_exception = false);
@@ -905,10 +914,11 @@
 
   // Vector API support (implemented in vectorIntrinsics.cpp)
   Node* box_vector(Node* in, const TypeInstPtr* vbox_type, BasicType elem_bt, int num_elem, bool deoptimize_on_exception = false);
   Node* unbox_vector(Node* in, const TypeInstPtr* vbox_type, BasicType elem_bt, int num_elem, bool shuffle_to_vector = false);
   Node* vector_shift_count(Node* cnt, int shift_op, BasicType bt, int num_elem);
+  void backfill_materialized(SafePointNode* map, uint begin, uint end, PEAState& as);
 };
 
 // Helper class to support building of control flow branches. Upon
 // creation the map and sp at bci are cloned and restored upon de-
 // struction. Typical use:
diff a/src/hotspot/share/opto/locknode.cpp b/src/hotspot/share/opto/locknode.cpp
--- a/src/hotspot/share/opto/locknode.cpp
+++ b/src/hotspot/share/opto/locknode.cpp
@@ -185,20 +185,175 @@
   if (stopped()) return;
 
   // the monitor object is not part of debug info expression stack
   pop();
 
+  if (DoPartialEscapeAnalysis) {
+    PEAState& state = jvms()->alloc_state();
+    VirtualState* vs = state.as_virtual(PEA(), obj);
+
+    if (vs != nullptr) {
+      vs->lock_inc();
+    }
+  }
+
   // Insert a FastLockNode which takes as arguments the current thread pointer,
   // the obj pointer & the address of the stack slot pair used for the lock.
   shared_lock(obj);
 }
 
 //------------------------------do_monitor_exit--------------------------------
 void Parse::do_monitor_exit() {
   kill_dead_locals();
 
+  // need to set it for monitor exit as well.
+  // OSR compiled methods can start with lock taken
+  C->set_has_monitors(true);
+  Node* obj = map()->peek_monitor_obj();
+
+  if (DoPartialEscapeAnalysis) {
+    PEAState& state = jvms()->alloc_state();
+    ObjID id = PEA()->is_alias(obj); //
+    if (id != nullptr && state.contains(id)) {
+      ObjectState* os = state.get_object_state(id);
+      if (os->is_virtual()) {
+        static_cast<VirtualState*>(os)->lock_dec();
+      } else {
+        auto materialized = state.get_materialized_value(id);
+        if (materialized != nullptr) {
+          obj = materialized;
+
+          if (obj->is_Phi()) {
+            pop();
+
+            // We need to split Phi + Unlock like this:
+            // +------+   +-----+ +------+
+            // |Region|   | obj | | obj' | (PEA materialized object)
+            // +------+   +-----+ +------+
+            //        \     |    /
+            //        +------------+
+            //        |phi|        |
+            //        +------------+
+            //               |P0
+            //           +--------------+
+            //           | UnlockNode   |
+            //           +--------------+
+            //
+            // split this phi because it helps EA and ME eliminate Unlock nodes.
+            // bytecode monitor_exit post-dominates the object, so PhiNode has been finalized.
+            // for GraphKit::shared_unlock(), the only side-effect is ctrl + abio + memory.
+            //
+            //
+            // +------+          +-----+                      +------+
+            // |Region|          | obj |                      | obj' |
+            // +------+          +-----+                      +------+
+            //                      |                         /
+            //                      |P0                      |P0
+            //                  +--------------+         +--------------+
+            //                  | UnlockNode   |         | UnlockNode   |
+            //                  +--------------+         +--------------+
+            //                    |   |abio |memory        |  |abio |memory
+            //                    |                 /-----/
+            //                    | ctrl           / ctrl
+            //                 +--------------------+
+            //                 | new_rgn            | ( new_rgn merges abio and memory as well)
+            //                 +--------------------+
+            //                    |ctrl |abio |memory
+            //                   +--------------------+
+            //                   | sfpt (map)         |
+            //                   +--------------------+
+            //
+            RegionNode* region = obj->in(0)->as_Region();
+            BoxLockNode* box = map()->peek_monitor_box()->as_BoxLock();
+
+            Node* new_rgn = new RegionNode(region->req());
+            gvn().set_type(new_rgn, Type::CONTROL);
+
+            bool merged = false;
+            GraphKit saved_ctx = {clone_map()->jvms()};
+
+            // reverse i to simulate merging normal paths.
+            // merge_memory_edges() will do GVN when i == 1
+            for (uint i = region->req()-1; i > 0; --i) {
+              Node* ctrl  = region->in(i);
+              Node* abio = nullptr;
+              MergeMemNode* mem = nullptr;
+
+              if (ctrl != nullptr && ctrl != C->top()) {
+                SafePointNode* curr = saved_ctx.clone_map();
+                GraphKit kit = { curr->jvms() };
+
+                kit.set_control(ctrl);
+                // We need to resume SafePointNode to the state as if it was the predecessor controlled by region->in(i).
+                for (uint j = 1; j < curr->req(); ++j) {
+                  Node* m = curr->in(j);
+
+                  if (j == TypeFunc::Memory) {
+                    if (m->is_Phi() && m->in(0) == region) {
+                      m = m->in(i);
+                    } else if (m->is_MergeMem()) {
+                      // a blank memory
+                      MergeMemNode* new_all_mem = MergeMemNode::make(MergeMemNode::make_empty_memory());
+                      new_all_mem->grow_to_match(m->as_MergeMem());
+                      for (MergeMemStream mms(m->as_MergeMem()); mms.next_non_empty(); ) {
+                        Node* p = mms.memory();
+                        if (p->is_Phi() && p->in(0) == region) {
+                          new_all_mem->set_req(mms.alias_idx(), p->in(i));
+                        } else {
+                          new_all_mem->set_req(mms.alias_idx(), p);
+                        }
+                      }
+                      m = new_all_mem;
+                    }
+                    curr->set_memory(m);
+                  } else if (m != nullptr && m->is_Phi() && m->in(0) == region) {
+                    curr->set_req(j, m->in(i));
+                  }
+                }
+
+                kit.shared_unlock(box, obj->in(i), true);
+
+                ctrl = kit.control();
+                mem = kit.merged_memory();
+                abio = kit.i_o();
+              } else {
+                assert(false, "impossible! monitorExit must post-dominate the PhiNode.");
+              }
+
+              new_rgn->init_req(i, ctrl);
+
+              if (!merged) {
+                merged = true;
+                set_control(new_rgn); // merge_memory_edges() requires that ctrl() is a RegionNode.
+                set_all_memory(mem);
+                set_i_o(abio);
+              } else {
+                merge_memory_edges(mem, i, false);
+                Node* phi = i_o();
+                if (!(phi->is_Phi() && phi->in(0) != new_rgn)) {
+                  phi = PhiNode::make(new_rgn, phi);
+                  gvn().set_type(phi, Type::ABIO);
+                  record_for_igvn(phi);
+                }
+                phi->set_req(i, abio);
+                set_i_o(phi);
+              }
+            }
+
+            new_rgn = _gvn.transform(new_rgn);
+            set_control(new_rgn);
+            record_for_igvn(new_rgn);
+
+            map()->pop_monitor();
+            return ;
+          }
+        }
+      }
+    }
+  }
+
   pop();                        // Pop oop to unlock
   // Because monitors are guaranteed paired (else we bail out), we know
   // the matching Lock for this Unlock.  Hence we know there is no need
   // for a null check on Unlock.
-  shared_unlock(map()->peek_monitor_box(), map()->peek_monitor_obj());
+  shared_unlock(map()->peek_monitor_box(), obj);
 }
diff a/src/hotspot/share/opto/macro.cpp b/src/hotspot/share/opto/macro.cpp
--- a/src/hotspot/share/opto/macro.cpp
+++ b/src/hotspot/share/opto/macro.cpp
@@ -1295,10 +1295,14 @@
 
   enum { too_big_or_final_path = 1, need_gc_path = 2 };
   Node *slow_region = nullptr;
   Node *toobig_false = ctrl;
 
+  if (PEAParanoid && alloc->materialized_cnt() > 0) {
+    fatal("[PEA] Expanding obj#%d which has been materialized.", alloc->_idx);
+  }
+
   // generate the initial test if necessary
   if (initial_slow_test != nullptr ) {
     assert (expand_fast_path, "Only need test if there is a fast path");
     slow_region = new RegionNode(3);
 
@@ -1948,28 +1952,36 @@
   // eliminated even if different objects are referenced in one locked region
   // (for example, OSR compilation of nested loop inside locked scope).
   if (EliminateNestedLocks ||
       oldbox->as_BoxLock()->is_simple_lock_region(nullptr, obj, nullptr)) {
     // Box is used only in one lock region. Mark this box as eliminated.
-    _igvn.hash_delete(oldbox);
-    oldbox->as_BoxLock()->set_eliminated(); // This changes box's hash value
-     _igvn.hash_insert(oldbox);
-
+    int locks = 0;
     for (uint i = 0; i < oldbox->outcnt(); i++) {
       Node* u = oldbox->raw_out(i);
       if (u->is_AbstractLock() && !u->as_AbstractLock()->is_non_esc_obj()) {
         AbstractLockNode* alock = u->as_AbstractLock();
         // Check lock's box since box could be referenced by Lock's debug info.
         if (alock->box_node() == oldbox) {
-          // Mark eliminated all related locks and unlocks.
+          locks++;
+
+          if (alock->obj_node() == obj) {
+            // Mark eliminated all related locks and unlocks.
 #ifdef ASSERT
-          alock->log_lock_optimization(C, "eliminate_lock_set_non_esc4");
+            alock->log_lock_optimization(C, "eliminate_lock_set_non_esc4");
 #endif
-          alock->set_non_esc_obj();
+            alock->set_non_esc_obj();
+            locks--;
+          }
         }
       }
     }
+    if (locks == 0) {
+      _igvn.hash_delete(oldbox);
+      oldbox->as_BoxLock()->set_eliminated(); // This changes box's hash value
+      _igvn.hash_insert(oldbox);
+    }
+
     return;
   }
 
   // Create new "eliminated" BoxLock node and use it in monitor debug info
   // instead of oldbox for the same object.
@@ -2110,11 +2122,11 @@
   }
 #ifdef ASSERT
   if (!alock->is_coarsened()) {
     // Check that new "eliminated" BoxLock node is created.
     BoxLockNode* oldbox = alock->box_node()->as_BoxLock();
-    assert(oldbox->is_eliminated(), "should be done already");
+    assert(oldbox->is_eliminated() || DoPartialEscapeAnalysis, "should be done already");
   }
 #endif
 
   alock->log_lock_optimization(C, "eliminate_lock");
 
diff a/src/hotspot/share/opto/parse.hpp b/src/hotspot/share/opto/parse.hpp
--- a/src/hotspot/share/opto/parse.hpp
+++ b/src/hotspot/share/opto/parse.hpp
@@ -29,10 +29,11 @@
 #include "ci/ciTypeFlow.hpp"
 #include "compiler/methodLiveness.hpp"
 #include "libadt/vectset.hpp"
 #include "oops/generateOopMap.hpp"
 #include "opto/graphKit.hpp"
+#include "opto/partialEscape.hpp"
 #include "opto/subnode.hpp"
 
 class BytecodeParseHistogram;
 class InlineTree;
 class Parse;
@@ -159,17 +160,27 @@
     uint               _count;          // how many times executed?  Currently only set by _goto's
     bool               _is_parsed;      // has this block been parsed yet?
     bool               _is_handler;     // is this block an exception handler?
     bool               _has_merged_backedge; // does this block have merged backedge?
     SafePointNode*     _start_map;      // all values flowing into this block
-    MethodLivenessResult _live_locals;  // lazily initialized liveness bitmap
+    mutable MethodLivenessResult _live_locals;  // lazily initialized liveness bitmap
     bool               _has_predicates; // Were predicates added before parsing of the loop head?
 
     int                _num_successors; // Includes only normal control flow.
     int                _all_successors; // Include exception paths also.
     Block**            _successors;
+    Block**            _predecessors;
+    Block*             _from_block;
+    int                _init_pnum;      // the pnum of Block where _state is copied from.
 
+    const MethodLivenessResult& liveness() const {
+      if (!_live_locals.is_valid()) {
+        _live_locals = flow()->outer()->method()->liveness_at_bci(start());
+      }
+      assert(_live_locals.is_valid(), "sanity check");
+      return _live_locals;
+    }
    public:
 
     // Set up the block data structure itself.
     Block(Parse* outer, int rpo);
 
@@ -187,10 +198,16 @@
     SafePointNode* start_map() const       { assert(is_merged(),"");   return _start_map; }
     void set_start_map(SafePointNode* m)   { assert(!is_merged(), ""); _start_map = m; }
 
     // True after any predecessor flows control into this block
     bool is_merged() const                 { return _start_map != nullptr; }
+    Block* from_block() const              { return _from_block; }
+    int init_pnum() const                  { return _init_pnum; }
+    PEAState& state()                      {
+      assert(is_merged(), "sanity check");
+      return _start_map->jvms()->alloc_state();
+    }
 
 #ifdef ASSERT
     // True after backedge predecessor flows control into this block
     bool has_merged_backedge() const       { return _has_merged_backedge; }
     void mark_merged_backedge(Block* pred) {
@@ -214,10 +231,16 @@
       assert((uint)i < (uint)all_successors(), "");
       return _successors[i];
     }
     Block* successor_for_bci(int bci);
 
+    Block* predecessor_at(int i) const {
+      assert(DoPartialEscapeAnalysis, "_predecessors is only available when DoPartialEscapeAnalysis is ON");
+      assert(i < _pred_count, "");
+      return _predecessors[i];
+    }
+
     int start() const                      { return flow()->start(); }
     int limit() const                      { return flow()->limit(); }
     int rpo() const                        { return flow()->rpo(); }
     int start_sp() const                   { return flow()->stack_size(); }
 
@@ -284,11 +307,11 @@
     // and all its phi nodes (if any).  The value returned is a
     // path number ("pnum").
     int add_new_path();
 
     // Initialize me by recording the parser's map.  My own map must be null.
-    void record_state(Parse* outer);
+    void record_state(Parse* outer, int pnum);
   };
 
 #ifndef PRODUCT
   // BytecodeParseHistogram collects number of bytecodes parsed, nodes constructed, and transformations.
   class BytecodeParseHistogram : public ArenaObj {
@@ -341,10 +364,11 @@
   friend class Block;
 
   // Variables which characterize this compilation as a whole:
 
   JVMState*     _caller;        // JVMS which carries incoming args & state.
+  PEAState*     _caller_state;  // current PEA state of caller
   float         _expected_uses; // expected number of calls to this code
   float         _prof_factor;   // discount applied to my profile counts
   int           _depth;         // Inline tree depth, for debug printouts
   const TypeFunc*_tf;           // My kind of function type
   int           _entry_bci;     // the osr bci or InvocationEntryBci
@@ -370,18 +394,21 @@
 #ifndef PRODUCT
   int _max_switch_depth;        // Debugging SwitchRanges.
   int _est_switch_depth;        // Debugging SwitchRanges.
 #endif
 
-  bool         _first_return;                  // true if return is the first to be parsed
+  int          _first_return;                  // true if return is the first to be parsed
   bool         _replaced_nodes_for_exceptions; // needs processing of replaced nodes in exception paths?
   uint         _new_idx;                       // any node with _idx above were new during this parsing. Used to trim the replaced nodes list.
 
  public:
   // Constructor
-  Parse(JVMState* caller, ciMethod* parse_method, float expected_uses);
+  Parse(JVMState* caller, ciMethod* parse_method, float expected_uses, PEAState* caller_state = nullptr);
 
+#ifndef PRODUCT
+  ~Parse();
+#endif
   virtual Parse* is_Parse() const { return (Parse*)this; }
 
   // Accessors.
   JVMState*     caller()        const { return _caller; }
   float         expected_uses() const { return _expected_uses; }
@@ -403,12 +430,18 @@
   void      set_wrote_stable(bool z)  { _wrote_stable = z; }
   bool         wrote_fields() const   { return _wrote_fields; }
   void     set_wrote_fields(bool z)   { _wrote_fields = z; }
   Node*    alloc_with_final() const   { return _alloc_with_final; }
   void set_alloc_with_final(Node* n)  {
-    assert((_alloc_with_final == nullptr) || (_alloc_with_final == n), "different init objects?");
-    _alloc_with_final = n;
+    if (DoPartialEscapeAnalysis) {
+      assert((_alloc_with_final == nullptr) || (_alloc_with_final == PEA()->is_alias(n)), 
+             "different init objects?");
+      _alloc_with_final = PEA()->is_alias(n);
+    } else {
+      assert((_alloc_with_final == nullptr) || (_alloc_with_final == n), "different init objects?");
+      _alloc_with_final = n;
+    }
   }
 
   Block*             block()    const { return _block; }
   ciBytecodeStream&  iter()           { return _iter; }
   Bytecodes::Code    bc()       const { return _iter.cur_bc(); }
@@ -450,11 +483,11 @@
   void  load_interpreter_state(Node* osr_buf);
 
   // Functions for managing basic blocks:
   void init_blocks();
   void load_state_from(Block* b);
-  void store_state_to(Block* b) { b->record_state(this); }
+  void store_state_to(Block* b, int pnum) { b->record_state(this, pnum); }
 
   // Parse all the basic blocks.
   void do_all_blocks();
 
   // Parse the current basic block
@@ -482,10 +515,11 @@
   // Helper: Merge the current mapping into the given basic block
   void merge_common(Block* target, int pnum);
   // Helper functions for merging individual cells.
   PhiNode *ensure_phi(       int idx, bool nocreate = false);
   PhiNode *ensure_memory_phi(int idx, bool nocreate = false);
+
   // Helper to merge the current memory state into the given basic block
   void merge_memory_edges(MergeMemNode* n, int pnum, bool nophi);
 
   // Parse this bytecode, and alter the Parsers JVM->Node mapping
   void do_one_bytecode();
